// import { Component, Inject, OnInit, PLATFORM_ID } from '@angular/core';
// import { isPlatformBrowser } from '@angular/common';
// import { EChartsOption } from 'echarts';
// import { BsModalService, BsModalRef } from 'ngx-bootstrap/modal';
// import { ModalContentComponent } from './modal-content/modal-content.component';

// @Component({
//   selector: 'app-root',
//   templateUrl: './app.component.html',
//   styleUrls: ['./app.component.css'],
// })
// export class AppComponent implements OnInit {
//   chartOption: EChartsOption | null = null;

//   drillDownChartOption: EChartsOption | null = null;
//   modalRef!: BsModalRef;

//   data: any[] = [
//     {
//       name: 'Fruits',
//       total: 300,
//       drilldown: [
//         { name: 'Apples', value: 120 },
//         { name: 'Oranges', value: 80 },
//         { name: 'Bananas', value: 100 },
//       ],
//     },
//     {
//       name: 'Vegetables',
//       total: 200,
//       drilldown: [
//         { name: 'Tomatoes', value: 90 },
//         { name: 'Peppers', value: 60 },
//         { name: 'Carrots', value: 50 },
//       ],
//     },
//   ];

//   constructor(
//     @Inject(PLATFORM_ID) private platformId: Object,
//     private modalService: BsModalService
//   ) {}

//   ngOnInit(): void {
//     if (isPlatformBrowser(this.platformId)) {
//       this.chartOption = {
//         tooltip: {
//           trigger: 'axis',
//           axisPointer: { type: 'shadow' },
//         },
//         xAxis: {
//           type: 'category',
//           data: ['Item A', 'Item B', 'Item C', 'Item D', 'Item E', 'Item F'],
//         },
//         yAxis: { type: 'value' },
//         series: [{ data: [120, 200, 150, 100, 270, 180], type: 'bar' }],
//       };

//       this.setChartOptions(
//         this.data.map((item) => ({
//           name: item.name,
//           value: item.total,
//         }))
//       );
//     }
//   }

//   onChartClick(event: any): void {
//     const itemData = event.seriesName;
//     // Data for the modal can be fetched or calculated here based on the itemData
//     this.openModalWithData(this.fetchDataForItem(itemData));
//   }

//   fetchDataForItem(itemName: string) {
//     // This is where you fetch or construct the data based on the bar clicked
//     return [
//       { attribute: 'Detail 1', value: 'Data A' },
//       { attribute: 'Detail 2', value: 'Data B' },
//       { attribute: 'Detail 3', value: 'Data C' },
//       { attribute: 'Detail 4', value: 'Data A' },
//       { attribute: 'Detail 5', value: 'Data B' },
//       { attribute: 'Detail 6', value: 'Data C' },
//     ];
//   }

//   openModalWithData(data: any): void {
//     const initialState = { list: data };
//     this.modalRef = this.modalService.show(ModalContentComponent, {
//       initialState,
//     });
//     this.modalRef.content.closeBtnName = 'Close';
//   }

//   //----------------------------------------------------------------
//   setChartOptions(data: any[]): void {
//     this.drillDownChartOption = {
//       tooltip: {
//         trigger: 'item',
//         formatter: '{a} <br/>{b} : {c}',
//       },
//       xAxis: {
//         type: 'category',
//         data: data.map((item) => item.name),
//       },
//       yAxis: {
//         type: 'value',
//       },
//       series: [
//         {
//           name: 'Categories',
//           type: 'bar',
//           data: data,
//           label: {
//             show: true,
//             position: 'inside',
//           },
//         },
//       ],
//     };
//   }

//   onDrillDownChartClick(event: any): void {
//     const selectedItem = this.data.find((item) => item.name === event.name);
//     if (selectedItem && selectedItem.drilldown) {
//       this.setChartOptions(selectedItem.drilldown);
//     }
//   }
// }

//----------------------------------------------------------------Echarts Drill Down ----------------------------------------------------------------
// import { Component, Inject, OnInit, PLATFORM_ID } from '@angular/core';
// import { isPlatformBrowser } from '@angular/common';
// import { EChartsOption } from 'echarts';
// import { BsModalService, BsModalRef } from 'ngx-bootstrap/modal';
// import { ModalContentComponent } from './modal-content/modal-content.component';

// @Component({
//   selector: 'app-root',
//   templateUrl: './app.component.html',
//   styleUrls: ['./app.component.css'],
// })
// export class AppComponent implements OnInit {
//   chartOption: EChartsOption | null = null;
//   drillDownChartOption: EChartsOption | null = null;
//   modalRef!: BsModalRef;

//   data: any[] = [
//     {
//       name: 'Fruits',
//       total: 300,
//       drilldown: [
//         { name: 'Apples', value: 120 },
//         { name: 'Oranges', value: 80 },
//         { name: 'Bananas', value: 100 },
//       ],
//     },
//     {
//       name: 'Vegetables',
//       total: 200,
//       drilldown: [
//         { name: 'Tomatoes', value: 90 },
//         { name: 'Peppers', value: 60 },
//         { name: 'Carrots', value: 50 },
//       ],
//     },
//     {
//       name: 'Dairy',
//       total: 150,
//       drilldown: [
//         { name: 'Milk', value: 70 },
//         { name: 'Cheese', value: 80 },
//       ],
//     },
//     {
//       name: 'Ornaments',
//       total: 250,
//       drilldown: [
//         { name: 'Gold', value: 150 },
//         { name: 'Silver', value: 100 },
//       ],
//     },
//     {
//       name: 'Beverages',
//       total: 180,
//       drilldown: [
//         { name: 'Coffee', value: 100 },
//         { name: 'Tea', value: 80 },
//       ],
//     },
//     {
//       name: 'Snacks',
//       total: 220,
//       drilldown: [
//         { name: 'Chips', value: 120 },
//         { name: 'Nuts', value: 100 },
//       ],
//     },
//   ];

//   constructor(
//     @Inject(PLATFORM_ID) private platformId: Object,
//     private modalService: BsModalService
//   ) {}

//   ngOnInit(): void {
//     if (isPlatformBrowser(this.platformId)) {
//       this.setMainChartOptions();
//     }
//   }

//   setMainChartOptions(): void {
//     this.chartOption = {
//       title: {
//         text: 'Drilldown Bar Chart',
//         left: 'center', // Center align the title
//         textStyle: {
//           fontWeight: 'bold', // Make title text bold
//           fontSize: 18, // Increase the font size
//         },
//       },
//       tooltip: {
//         trigger: 'axis',
//         axisPointer: { type: 'shadow' },
//       },
//       xAxis: {
//         type: 'category',
//         data: this.data.map((item) => item.name),
//         name: 'Category Types',
//         nameTextStyle: {
//           fontWeight: 'bold', // Make x-axis label bold
//           fontSize: 16, // Increase the font size
//         },
//         nameLocation: 'middle', // Centers the axis name
//         nameGap: 30, // Increase gap to position the name better
//       },
//       yAxis: {
//         type: 'value',
//         name: 'Bar Chart',
//         nameTextStyle: {
//           fontWeight: 'bold', // Make y-axis label bold
//           fontSize: 16, // Increase the font size
//         },
//         nameLocation: 'middle', // Centers the axis name
//         nameRotate: 90, // Rotate to align vertically
//         nameGap: 50, // Adjust gap to avoid clipping with axis labels
//       },
//       series: [
//         {
//           name: 'Categories',
//           type: 'bar',
//           data: this.data.map((item) => ({
//             name: item.name,
//             value: item.total,
//           })),
//           label: {
//             show: true,
//             position: 'inside',
//           },
//         },
//       ],
//     };
//     this.drillDownChartOption = null; // Initially hide the drilldown chart
//   }

//   onChartClick(event: any): void {
//     const selectedItem = this.data.find((item) => item.name === event.name);
//     if (selectedItem && selectedItem.drilldown) {
//       this.setDrillDownChartOptions(selectedItem.drilldown);
//     }
//   }

//   setDrillDownChartOptions(drilldownData: any[]): void {
//     this.drillDownChartOption = {
//       tooltip: {
//         trigger: 'item',
//         formatter: '{a} <br/>{b} : {c}',
//       },
//       xAxis: {
//         type: 'category',
//         data: drilldownData.map((item) => item.name),
//       },
//       yAxis: {
//         type: 'value',
//       },
//       series: [
//         {
//           name: 'Details',
//           type: 'bar',
//           data: drilldownData,
//           label: {
//             show: true,
//             position: 'inside',
//           },
//         },
//       ],
//     };
//     this.chartOption = null; // Optionally hide the main chart when displaying the drilldown
//   }

//   onDrillDownChartClick(event: any): void {
//     // Handle click on the drilldown chart (e.g., navigating back to the main chart)
//     this.setMainChartOptions(); // This will show the main chart again
//   }
// }

// import {
//   Component,
//   OnInit,
//   OnDestroy,
//   NgZone,
//   ViewChild,
//   ElementRef,
//   PLATFORM_ID,
//   Inject,
// } from '@angular/core';
// import { isPlatformBrowser } from '@angular/common';
// import * as am4core from '@amcharts/amcharts4/core';
// import * as am4charts from '@amcharts/amcharts4/charts';
// import am4themes_animated from '@amcharts/amcharts4/themes/animated';

// interface ChartData {
//   category: string;
//   value: number;
//   subData?: ChartData[]; // Optional because not all items may have subdata
// }

// @Component({
//   selector: 'app-root',
//   templateUrl: './app.component.html',
//   styleUrls: ['./app.component.css'],
// })
// export class AppComponent implements OnInit, OnDestroy {
//   private chart!: am4charts.XYChart;
//   private dataHistory: ChartData[][] = []; // Stack to keep track of data states

//   constructor(
//     private zone: NgZone,
//     @Inject(PLATFORM_ID) private platformId: Object
//   ) {}

//   ngOnInit(): void {
//     if (isPlatformBrowser(this.platformId)) {
//     }
//   }

//   ngAfterViewInit() {
//     if (isPlatformBrowser(this.platformId)) {
//     }
//     this.zone.runOutsideAngular(() => {
//       am4core.useTheme(am4themes_animated);

//       let chart = am4core.create('chartdiv', am4charts.XYChart);
//       chart.hiddenState.properties.opacity = 0; // this creates initial fade-in

//       chart.data = [
//         {
//           category: 'Fruits',
//           value: 300,
//           subData: [
//             { category: 'Apples', value: 120, color: am4core.color('#845EC2') },
//             { category: 'Oranges', value: 80, color: am4core.color('#D65DB1') },
//             {
//               category: 'Bananas',
//               value: 100,
//               color: am4core.color('#FF6F91'),
//             },
//           ],
//         },
//         {
//           category: 'Vegetables',
//           value: 250,
//           subData: [
//             { category: 'Tomatoes', value: 100 },
//             { category: 'Peppers', value: 80 },
//             { category: 'Carrots', value: 70 },
//           ],
//         },
//         {
//           category: 'Grains',
//           value: 180,
//           subData: [
//             { category: 'Rice', value: 90 },
//             { category: 'Oats', value: 60 },
//             { category: 'Quinoa', value: 30 },
//           ],
//         },
//         {
//           category: 'Legumes',
//           value: 220,
//           subData: [
//             { category: 'Lentils', value: 110 },
//             { category: 'Chickpeas', value: 70 },
//             { category: 'Black Beans', value: 40 },
//           ],
//         },
//         {
//           category: 'Nuts and Seeds',
//           value: 150,
//           subData: [
//             { category: 'Almonds', value: 60 },
//             { category: 'Cashews', value: 50 },
//             { category: 'Flax Seeds', value: 40 },
//           ],
//         },
//         {
//           category: 'Herbs and Spices',
//           value: 120,
//           subData: [
//             { category: 'Basil', value: 50 },
//             { category: 'Turmeric', value: 40 },
//             { category: 'Cinnamon', value: 30 },
//           ],
//         },
//         {
//           category: 'Dairy Alternatives',
//           value: 180,
//           subData: [
//             { category: 'Almond Milk', value: 80 },
//             { category: 'Soy Milk', value: 60 },
//             { category: 'Coconut Yogurt', value: 40 },
//           ],
//         },
//         {
//           category: 'Beverages',
//           value: 160,
//           subData: [
//             { category: 'Tea', value: 90 },
//             { category: 'Coffee', value: 40 },
//             { category: 'Vegetable Juice', value: 30 },
//           ],
//         },
//       ];

//       let categoryAxis = chart.xAxes.push(new am4charts.CategoryAxis());
//       categoryAxis.dataFields.category = 'category';
//       categoryAxis.renderer.grid.template.location = 0;

//       let valueAxis = chart.yAxes.push(new am4charts.ValueAxis());

//       let series = chart.series.push(new am4charts.ColumnSeries());
//       series.dataFields.valueY = 'value';
//       series.dataFields.categoryX = 'category';
//       series.columns.template.tooltipText = '{categoryX}: [bold]{valueY}[/]';
//       series.columns.template.fillOpacity = 0.8;

//       let columnTemplate = series.columns.template;
//       columnTemplate.strokeWidth = 2;
//       columnTemplate.strokeOpacity = 1;

//       // Add title
//       let title = chart.titles.create();
//       title.text = 'Amcharts Drill down bar chart';
//       title.fontSize = 20;
//       title.marginBottom = 20;
//       title.align = 'center';

//       // Optionally, add a back button to return to main data
//       let backButton = chart.createChild(am4core.Button);
//       // Assuming backButton is an instance of am4core.Button
//       backButton.label!.text = 'Back'; // Using non-null assertion operator

//       backButton.align = 'right';
//       backButton.events.on('hit', () => {
//         chart.data = [
//           {
//             category: 'Fruits',
//             value: 300,
//             subData: [
//               {
//                 category: 'Apples',
//                 value: 120,
//                 color: am4core.color('#845EC2'),
//               },
//               {
//                 category: 'Oranges',
//                 value: 80,
//                 color: am4core.color('#D65DB1'),
//               },
//               {
//                 category: 'Bananas',
//                 value: 100,
//                 color: am4core.color('#FF6F91'),
//               },
//             ],
//           },
//           {
//             category: 'Vegetables',
//             value: 250,
//             subData: [
//               { category: 'Tomatoes', value: 100 },
//               { category: 'Peppers', value: 80 },
//               { category: 'Carrots', value: 70 },
//             ],
//           },
//           {
//             category: 'Grains',
//             value: 180,
//             subData: [
//               { category: 'Rice', value: 90 },
//               { category: 'Oats', value: 60 },
//               { category: 'Quinoa', value: 30 },
//             ],
//           },
//           {
//             category: 'Legumes',
//             value: 220,
//             subData: [
//               { category: 'Lentils', value: 110 },
//               { category: 'Chickpeas', value: 70 },
//               { category: 'Black Beans', value: 40 },
//             ],
//           },
//           {
//             category: 'Nuts and Seeds',
//             value: 150,
//             subData: [
//               { category: 'Almonds', value: 60 },
//               { category: 'Cashews', value: 50 },
//               { category: 'Flax Seeds', value: 40 },
//             ],
//           },
//           {
//             category: 'Herbs and Spices',
//             value: 120,
//             subData: [
//               { category: 'Basil', value: 50 },
//               { category: 'Turmeric', value: 40 },
//               { category: 'Cinnamon', value: 30 },
//             ],
//           },
//           {
//             category: 'Dairy Alternatives',
//             value: 180,
//             subData: [
//               { category: 'Almond Milk', value: 80 },
//               { category: 'Soy Milk', value: 60 },
//               { category: 'Coconut Yogurt', value: 40 },
//             ],
//           },
//           {
//             category: 'Beverages',
//             value: 160,
//             subData: [
//               { category: 'Tea', value: 90 },
//               { category: 'Coffee', value: 40 },
//               { category: 'Vegetable Juice', value: 30 },
//             ],
//           },
//         ];
//         categoryAxis.dataFields.category = 'category';
//       });

//       series.columns.template.events.on('hit', (ev) => {
//         // let data = ev.target.dataItem.dataContext['subData'];
//         // let data = ev.target.dataItem?.dataContext as any;
//         // if (data) {
//         //   chart.data = data;
//         // }
//         let data = ev.target.dataItem?.dataContext as ChartData;
//         if (data && data.subData) {
//           chart.data = data.subData;
//           categoryAxis.dataFields.category = 'category';
//           series.dataFields.valueY = 'value';
//           series.dataFields.categoryX = 'category';
//           series.columns.template.propertyFields.fill = 'D65DB1'; // Ensure the color property is used
//         }
//       });

//       this.chart = chart;
//     });
//   }

//   // ngOnDestroy() {
//   //   this.zone.runOutsideAngular(() => {
//   //     if (this.chart) {
//   //       this.chart.dispose();
//   //     }
//   //   });
//   // }
//   ngOnDestroy(): void {
//     this.zone.runOutsideAngular(() => {
//       if (this.chart) {
//         this.chart.dispose();
//       }
//     });
//   }
// }

// import {
//   Component,
//   NgZone,
//   OnDestroy,
//   OnInit,
//   Inject,
//   PLATFORM_ID,
// } from '@angular/core';
// import { isPlatformBrowser } from '@angular/common';

// @Component({
//   selector: 'app-root',
//   template: '<div id="chartdiv" style="width: 100%; height: 500px;"></div>',
//   styleUrls: ['./app.component.css'],
// })
// export class AppComponent implements OnInit, OnDestroy {
//   private chart: any; // Using 'any' to avoid compilation errors before amCharts are loaded

//   constructor(
//     private zone: NgZone,
//     @Inject(PLATFORM_ID) private platformId: Object
//   ) {}

//   ngOnInit(): void {
//     if (isPlatformBrowser(this.platformId)) {
//       this.zone.runOutsideAngular(() => {
//         this.loadScripts();
//       });
//     }
//   }

//   private loadScripts(): void {
//     import('@amcharts/amcharts4/core').then((am4core) => {
//       import('@amcharts/amcharts4/charts').then((am4charts) => {
//         import('@amcharts/amcharts4/themes/animated').then(
//           (am4themes_animated) => {
//             am4core.useTheme(am4themes_animated.default);
//             this.initChart(am4core, am4charts);
//           }
//         );
//       });
//     });
//   }

//   private initChart(am4core: any, am4charts: any): void {
//     const chart = am4core.create('chartdiv', am4charts.XYChart);
//     let title = chart.titles.create();
//     title.text = 'Stacked Bar Chart';
//     title.fontSize = 20;
//     title.marginBottom = 20;
//     title.align = 'center';

//     // Set up the chart data
//     chart.data = [
//       {
//         category: 'Category 1',
//         firstValue: 60,
//         secondValue: 40,
//       },
//       {
//         category: 'Category 2',
//         firstValue: 30,
//         secondValue: 90,
//       },
//       {
//         category: 'Category 3',
//         firstValue: 60,
//         secondValue: 40,
//       },
//       {
//         category: 'Category 4',
//         firstValue: 30,
//         secondValue: 90,
//       },
//       {
//         category: 'Category 5',
//         firstValue: 60,
//         secondValue: 40,
//       },
//       {
//         category: 'Category 6',
//         firstValue: 30,
//         secondValue: 90,
//       },
//     ];

//     let categoryAxis = chart.xAxes.push(new am4charts.CategoryAxis());
//     categoryAxis.dataFields.category = 'category';

//     let valueAxis = chart.yAxes.push(new am4charts.ValueAxis());

//     // Create series for the first value
//     let series1 = chart.series.push(new am4charts.ColumnSeries());
//     series1.dataFields.valueY = 'firstValue';
//     series1.dataFields.categoryX = 'category';
//     series1.name = 'First Value';
//     series1.stacked = true;

//     // Create series for the second value
//     let series2 = chart.series.push(new am4charts.ColumnSeries());
//     series2.dataFields.valueY = 'secondValue';
//     series2.dataFields.categoryX = 'category';
//     series2.name = 'Second Value';
//     series2.stacked = true;

//     this.chart = chart;
//   }

//   ngOnDestroy(): void {
//     this.zone.runOutsideAngular(() => {
//       if (this.chart) {
//         this.chart.dispose();
//       }
//     });
//   }
// }

// import {
//   Component,
//   NgZone,
//   OnDestroy,
//   AfterViewInit,
//   Inject,
//   PLATFORM_ID,
// } from '@angular/core';
// import { isPlatformBrowser } from '@angular/common';

// @Component({
//   selector: 'app-root',
//   template: '<div id="chartdiv" style="width: 100%; height: 500px;"></div>',
//   styleUrls: ['./app.component.css'],
// })
// export class AppComponent implements AfterViewInit, OnDestroy {
//   private chart: any; // Using 'any' to simplify access to amCharts methods
//   private dataHistory: any[] = []; // Stack for storing historical data for "back" navigation

//   constructor(
//     private zone: NgZone,
//     @Inject(PLATFORM_ID) private platformId: Object
//   ) {}

//   ngAfterViewInit(): void {
//     if (isPlatformBrowser(this.platformId)) {
//       this.zone.runOutsideAngular(() => {
//         this.loadScripts();
//       });
//     }
//   }

//   private loadScripts(): void {
//     import('@amcharts/amcharts4/core').then((am4core) => {
//       import('@amcharts/amcharts4/charts').then((am4charts) => {
//         import('@amcharts/amcharts4/themes/animated').then(
//           (am4themes_animated) => {
//             am4core.useTheme(am4themes_animated.default);
//             this.initChart(am4core, am4charts);
//           }
//         );
//       });
//     });
//   }

//   private initChart(am4core: any, am4charts: any): void {
//     const chart = am4core.create('chartdiv', am4charts.XYChart);

//     let title = chart.titles.create();
//     title.text = 'Drilldown Stacked Bar Chart';
//     title.fontSize = 20;
//     title.marginBottom = 20;
//     title.align = 'center';
//     chart.data = this.getInitialData();

//     let categoryAxis = chart.xAxes.push(new am4charts.CategoryAxis());
//     categoryAxis.dataFields.category = 'category';
//     let valueAxis = chart.yAxes.push(new am4charts.ValueAxis());

//     const createSeries = (field: string, name: string) => {
//       let series = chart.series.push(new am4charts.ColumnSeries());
//       series.dataFields.valueY = field;
//       series.dataFields.categoryX = 'category';
//       series.name = name;
//       series.stacked = true;
//       series.columns.template.tooltipText = '{name}: [bold]{valueY}[/]';
//       series.columns.template.events.on(
//         'hit',
//         (ev: { target: { dataItem: { dataContext: any } } }) => {
//           let data = ev.target.dataItem.dataContext;
//           if (data.subData) {
//             this.dataHistory.push(chart.data);
//             chart.data = data.subData;
//           }
//         }
//       );
//     };

//     createSeries('firstValue', 'First Value');
//     createSeries('secondValue', 'Second Value');

//     // Add a back button
//     let backButton = chart.createChild(am4core.Button);
//     backButton.label.text = 'Back';
//     backButton.align = 'right';
//     backButton.events.on('hit', () => {
//       if (this.dataHistory.length > 0) {
//         chart.data = this.dataHistory.pop();
//       }
//     });

//     this.chart = chart;
//   }

//   // private getInitialData(): any[] {
//   //   return [
//   //     {
//   //       category: 'Category 1',
//   //       firstValue: 60,
//   //       secondValue: 40,
//   //       subData: [
//   //         { category: 'Subcategory 1.1', firstValue: 30, secondValue: 15 },
//   //         { category: 'Subcategory 1.2', firstValue: 30, secondValue: 25 },
//   //       ],
//   //     },
//   //     {
//   //       category: 'Category 2',
//   //       firstValue: 30,
//   //       secondValue: 90,
//   //       subData: [
//   //         { category: 'Subcategory 2.1', firstValue: 15, secondValue: 45 },
//   //         { category: 'Subcategory 2.2', firstValue: 15, secondValue: 45 },
//   //       ],
//   //     },
//   //     // Additional categories can be added here
//   //   ];
//   // }
//   private getInitialData(): any[] {
//     return [
//       {
//         category: 'Fruits',
//         firstValue: 200,
//         secondValue: 100,
//         subData: [
//           { category: 'Apples', firstValue: 120, secondValue: 60 },
//           { category: 'Bananas', firstValue: 80, secondValue: 40 },
//         ],
//       },
//       {
//         category: 'Vegetables',
//         firstValue: 150,
//         secondValue: 120,
//         subData: [
//           { category: 'Tomatoes', firstValue: 75, secondValue: 50 },
//           { category: 'Carrots', firstValue: 75, secondValue: 70 },
//         ],
//       },
//       {
//         category: 'Legumes',
//         firstValue: 160,
//         secondValue: 90,
//         subData: [
//           { category: 'Lentils', firstValue: 100, secondValue: 60 },
//           { category: 'Chickpeas', firstValue: 60, secondValue: 30 },
//         ],
//       },
//       {
//         category: 'Grains',
//         firstValue: 180,
//         secondValue: 150,
//         subData: [
//           { category: 'Quinoa', firstValue: 90, secondValue: 60 },
//           { category: 'Rice', firstValue: 90, secondValue: 90 },
//         ],
//       },
//       {
//         category: 'Nuts and Seeds',
//         firstValue: 100,
//         secondValue: 50,
//         subData: [
//           { category: 'Almonds', firstValue: 60, secondValue: 30 },
//           { category: 'Walnuts', firstValue: 40, secondValue: 20 },
//         ],
//       },
//     ];
//   }

//   ngOnDestroy(): void {
//     this.zone.runOutsideAngular(() => {
//       if (this.chart) {
//         this.chart.dispose();
//       }
//     });
//   }
// }

// import { Component, ViewChild, ElementRef, AfterViewInit } from '@angular/core';

// @Component({
//   selector: 'app-root',
//   templateUrl: './app.component.html',
//   styleUrl: './app.component.css',
// })
// export class AppComponent implements AfterViewInit {
//   @ViewChild('videoplayer', { static: false })
//   videoPlayer!: ElementRef<HTMLVideoElement>;
//   videoList = ['assets/bunny.mp4', 'assets/bunny1.mp4'];

//   videos = [
//     { src: 'assets/bunny.mp4', thumb: 'assets/thumbnails/bunny.png' },
//     { src: 'assets/bunny1.mp4', thumb: 'assets/thumbnails/bunny1.png' },
//     { src: 'assets/bunny.mp4', thumb: 'assets/thumbnails/bunny.png' },
//     { src: 'assets/bunny1.mp4', thumb: 'assets/thumbnails/bunny1.png' },
//   ];
//   currentVideoIndex = 0;

//   ngAfterViewInit() {
//     // Ensure this event listener is connected after the view is initialized
//     this.videoPlayer.nativeElement.addEventListener('ended', () =>
//       this.loadNextVideo()
//     );
//     this.playVideo(); // Optionally start the first video automatically
//   }

//   setVideo(index: number): void {
//     this.currentVideoIndex = index;
//     this.playVideo();
//   }

//   toggleVideo(): void {
//     if (this.videoPlayer && this.videoPlayer.nativeElement) {
//       const video = this.videoPlayer.nativeElement;
//       if (video.paused) {
//         video.play();
//       } else {
//         video.pause();
//       }
//     }
//   }

//   getVideoStatus(): string {
//     if (this.videoPlayer && this.videoPlayer.nativeElement) {
//       const video = this.videoPlayer.nativeElement;
//       return video && !video.paused ? 'Pause' : 'Play';
//     }
//     return 'Loading...'; // Default text while loading
//   }

//   loadNextVideo() {
//     this.currentVideoIndex =
//       (this.currentVideoIndex + 1) % this.videoList.length;
//     if (this.videoPlayer && this.videoPlayer.nativeElement) {
//       const video = this.videoPlayer.nativeElement;
//       video.src = this.videoList[this.currentVideoIndex];
//       video.load(); // Force reload of the new video source
//       video.play(); // Automatically play the new video
//     }
//   }

//   playVideo(): void {
//     // if (this.videoPlayer && this.videoPlayer.nativeElement) {
//     //   this.videoPlayer.nativeElement.play();
//     // }
//     const video = this.videoPlayer.nativeElement;
//     video.src = this.videos[this.currentVideoIndex].src;
//     video.load();
//     video.play();
//   }
// }

import { Component, VERSION } from '@angular/core';
import { SafeResourceUrl, DomSanitizer } from '@angular/platform-browser';

@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
  styleUrl: './app.component.css',
})
export class AppComponent {
  name = 'Angular ' + VERSION.major;
  // url = 'https://view.officeapps.live.com/op/embed.aspx?src=http://localhost:5000/assets/file-sample_1MB.doc';

  urlDoc: string = `https://view.officeapps.live.com/op/embed.aspx?src=https://stackblitz.com/storage/blobs/eyJfcmFpbHMiOnsibWVzc2FnZSI6IkJBaHBBdkpMIiwiZXhwIjpudWxsLCJwdXIiOiJibG9iX2lkIn19--e75389b18343665404852ed4cba8bd25938fa9bd/file-sample_1MB.doc`;

  urlxl: string =
    'https://view.officeapps.live.com/op/embed.aspx?src=https://go.microsoft.com/fwlink/?LinkID=521962';

  urlppt: string =
    'https://view.officeapps.live.com/op/embed.aspx?src=  http://www.dickinson.edu/download/downloads/id/1076/sample_powerpoint_slides.pptx';

  urlSafe: SafeResourceUrl | undefined;

  constructor(public sanitizer: DomSanitizer) {}

  ngOnInit() {
    this.urlSafe = this.sanitizer.bypassSecurityTrustResourceUrl(this.urlDoc);
  }

  selectDocumentType(type: any) {
    switch (type) {
      case 'doc':
        this.urlSafe = this.sanitizer.bypassSecurityTrustResourceUrl(
          this.urlDoc
        );
        break;
      case 'xl':
        this.urlSafe = this.sanitizer.bypassSecurityTrustResourceUrl(
          this.urlxl
        );
        break;
      case 'ppt':
        this.urlSafe = this.sanitizer.bypassSecurityTrustResourceUrl(
          this.urlppt
        );
        break;
      default:
        this.urlSafe = this.sanitizer.bypassSecurityTrustResourceUrl(
          this.urlDoc
        );
    }
  }
}
